#ifndef SCREENCASTINGREQUEST_H
#define SCREENCASTINGREQUEST_H

#include "screencasting.h"
#include <QObject>

class ScreencastingStream;

class ScreencastingRequest : public QObject
{
    Q_OBJECT
    Q_PROPERTY(QString uuid READ uuid WRITE setUuid NOTIFY uuidChanged)
    Q_PROPERTY(quint32 nodeId READ nodeId NOTIFY nodeIdChanged)

public:
    ScreencastingRequest(QObject *parent = nullptr);
    ~ScreencastingRequest();

    void setUuid(const QString &uuid);
    QString uuid() const;
    quint32 nodeId() const;

    void create(Screencasting *screencasting);
Q_SIGNALS:
    void nodeIdChanged(quint32 nodeId);
    void uuidChanged(const QString &uuid);
    void closeRunningStreams();
    void cursorModeChanged(Screencasting::CursorMode cursorMode);

private:
    void setNodeid(uint nodeId);

    ScreencastingStream *m_stream = nullptr;
    QString m_uuid;
    KWayland::Client::Output *m_output = nullptr;
    quint32 m_nodeId = 0;
};

#endif // SCREENCASTINGREQUEST_H
