//
// Created by hxf on 9/25/23.
//

#include "SignalListener.h"

#include <QCoreApplication>
#include <QDBusError>
#include <QDBusConnection>
#include <QDBusServiceWatcher>
#include <QDebug>
#include <QProcess>
#include <QDir>

void SignalListener::printMsg(QDBusVariant winId) {
    qDebug() << winId.variant();
}

void SignalListener::start(const QVariant &) {
    iface = new QDBusInterface(SERVICE_NAME, "/", "org.ukui.panel.signalforwarding",
                               QDBusConnection::sessionBus(), this);
    if (!iface->isValid()) {
        fprintf(stderr, "%s\n",
                qPrintable(QDBusConnection::sessionBus().lastError().message()));
        QCoreApplication::instance()->quit();
    }

    QMetaObject::Connection con = connect(iface, SIGNAL(titleChanged(QDBusVariant)), this, SLOT(printMsg(QDBusVariant)));
    connect(iface, SIGNAL(windowAdded(QDBusVariant)), this, SLOT(printMsg(QDBusVariant)));
    connect(iface, SIGNAL(windowRemoved(QDBusVariant)), this, SLOT(printMsg(QDBusVariant)));

    if (con) {
        qDebug() << con;
    } else {
        qDebug() << "gg";
    }
}


int main(int argc, char **argv)
{
    QCoreApplication app(argc, argv);

    if (!QDBusConnection::sessionBus().isConnected()) {
        fprintf(stderr, "Cannot connect to the D-Bus session bus.\n"
                        "To start it, run:\n"
                        "\teval `dbus-launch --auto-syntax`\n");
        return 1;
    }

    QDBusServiceWatcher serviceWatcher(SERVICE_NAME, QDBusConnection::sessionBus(),
                                       QDBusServiceWatcher::WatchForRegistration);

    SignalListener ping;
    QObject::connect(&serviceWatcher, &QDBusServiceWatcher::serviceRegistered,
                     &ping, &SignalListener::start);

    QProcess signalforwarding;
    signalforwarding.start("signalforwarding");

    app.exec();
}