#ifndef ALWAYSDISPLAYONPANEL_H
#define ALWAYSDISPLAYONPANEL_H

#include <QObject>
#include <QFrame>
#include <QWidget>
#include <QVBoxLayout>

#include <ukcc/interface/interface.h>
#include <ukcc/widgets/titlelabel.h>
#include <ukcc/widgets/comboxframe.h>
#include <ukcc/widgets/fixlabel.h>
#include "kswitchbutton.h"
using namespace kdk;

#define UKUI_PANEL_SETTINGS                 "org.ukui.panel.settings"
#define SHOW_TASKVIEW                       "showtaskview"
#define SHOW_NIGHTMODE                      "shownightmode"

class AlwaysDisplayonPanel : public QFrame
{
    Q_OBJECT
public:
    explicit AlwaysDisplayonPanel(QWidget *parent = nullptr);

signals:

private:
    void setFrame_Noframe(QFrame *frame);
    void displayTaskview();
    void panelBtnDisplayChanged();


    QVBoxLayout *m_alwaysDisplayonPanelLayout;

    QFrame *m_taskviewDisplayFrame;
    QHBoxLayout *m_taskviewDisplayLayout;
    QLabel *m_taskviewDisplayLabel;
    KSwitchButton *m_taskviewDisplayBtn;

    QGSettings *m_panelSettings;

private slots:

};

#endif // ALWAYSDISPLAYONPANEL_H
