#ifndef UKCCPLUGIN_H
#define UKCCPLUGIN_H

#include <QObject>
#include <QWidget>
#include <QTranslator>
#include <QIcon>
#include <QLocale>
#include <QApplication>

#include <ukcc/interface/interface.h>
#include <ukcc/widgets/titlelabel.h>
#include <ukcc/widgets/comboxframe.h>
#include <ukcc/widgets/fixlabel.h>
#include "kswitchbutton.h"

#include "alwaysdisplayonpanel.h"
#include "generalsettings.h"
using namespace kdk;


#include <QVBoxLayout>

class UkccPlugin : public QObject, CommonInterface
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "org.ukcc.CommonInterface")
    Q_INTERFACES(CommonInterface)

public:

    UkccPlugin();
    ~UkccPlugin();

    QString plugini18nName()        Q_DECL_OVERRIDE;
    int pluginTypes()               Q_DECL_OVERRIDE;
    QWidget *pluginUi()             Q_DECL_OVERRIDE;
    bool isEnable() const           Q_DECL_OVERRIDE;
    const QString name() const      Q_DECL_OVERRIDE;
    bool isShowOnHomePage() const   Q_DECL_OVERRIDE;
    QIcon icon() const              Q_DECL_OVERRIDE;
    QString translationPath() const Q_DECL_OVERRIDE;

    void initUI();
    void setFrame_Noframe(QFrame *frame);
    void displayBtnOnPanel();
    void generalSettings();
    QFrame *setLine(QFrame *frame);

private:
    QString pluginName;
    int pluginType;
    QWidget *widget;
    bool mFirstLoad;

    QVBoxLayout *mverticalLayout;
    TitleLabel *CustomTitleLabel;
    TitleLabel *m_panelDisplayLabel;
    AlwaysDisplayonPanel *m_alwaysDisplayonPanelFrame;
    GeneralSettings *m_generalSettingsFrame;

private:
    void initSearchText();      // 搜索翻译
};

#endif // UKCCPLUGIN_H
